#!/usr/bin/env python
# -*- coding: utf-8 -*-
# 
# Copyright 2020
#   Author: Gonzalo Belcredi, gbelcredi@fing.edu.uy
#   Instituto de Ingenieria Electrica, Facultad de Ingenieria,
#   Universidad de la Republica, Uruguay.
# 
# This is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
# 
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.

from PIL import Image
import numpy as np


img = Image.open('images/image.png' )
img.load()
data = np.asarray( img, dtype="int8" )
img.show()


filas, columnas = data.shape
print("filas: ", filas, ", columnas: ", columnas)


sync_start = [0,128,255]*10
sync_end = [0,0,0,128,255,255,128,0,0,0]*3

sync_frame = sync_start
for i in range(0,filas-2):
    sync_frame = np.vstack((sync_frame,[128]*30)) # 50% de gris
sync_frame = np.vstack((sync_frame,sync_end))

print sync_frame
print sync_frame.shape

framed_data = np.hstack((sync_frame,data))


framed_image = Image.fromarray(framed_data.astype('uint8'))
framed_image.show()
framed_image.save('images/imagen_transmitida.png')



filas, columnas = framed_data.shape
print("filas (framed): ", filas, ", columnas (framed): ", columnas)

array = framed_data.flatten()
array = array.astype('uint8')
array_bin = bytearray(array)

f = open("dat/imagen_bin.dat", "w")
f.write(array_bin)
f.close()
